﻿using EonaCat.HID.EventArguments;
using System;
using System.Collections.Generic;

namespace EonaCat.HID
{
    /// <summary>
    /// Interface for manager to enumerate devices and monitor connect/disconnect
    /// </summary>
    public interface IHidManager
    {
        /// <summary>
        /// Enumerate all connected HID devices matching optional VendorId/ProductId filters
        /// </summary>
        IEnumerable<IHid> Enumerate(ushort? vendorId = null, ushort? productId = null);

        /// <summary>
        /// Event is raised when a HID device is inserted
        /// </summary>
        event EventHandler<HidEventArgs> OnDeviceInserted;

        /// <summary>
        /// Event is raised when a HID device is removed
        /// </summary>
        event EventHandler<HidEventArgs> OnDeviceRemoved;
    }
}